import pygame
from Mesh3D import *  # Importujemy naszą klasę Mesh3D z pliku Mesh3D.py
from pygame.locals import *
from OpenGL.GL import *
from OpenGL.GLU import *

from HelloObject import Object
from Transform import Transform
from Rotate import Rotate

pygame.init()  # Inicjujemy moduły Pygame


screen_width = 500
screen_height = 500
# Tworzymy okno 500×500 z trybem OpenGL i podwójnym buforowaniem
screen = pygame.display.set_mode((screen_width,
                                    screen_height),
                                    DOUBLEBUF|OPENGL)
pygame.display.set_caption('OpenGL in Python')
done = False
white = pygame.Color(255, 255, 255)
glLightfv(GL_LIGHT0, GL_AMBIENT,  (1, 0, 1, 1))  # np. fioletowe ambient
glLightfv(GL_LIGHT0, GL_DIFFUSE,  (1, 1, 0, 1))  # np. żółte diffuse
glLightfv(GL_LIGHT0, GL_SPECULAR, (0, 1, 0, 1))  # np. zielone specular

mesh = Cube(colorFill = True, draw_type = GL_POLYGON)  # Tworzymy obiekt siatki (mesh)
mesh2 = Cube(draw_type = GL_POLYGON)
gluPerspective(60, screen_width / screen_height, 0.1, 100.0)

#glOrtho(-1, 1, 1, -1, 0.1, 50.0)
glTranslatef(0.0, 0.0, -3.5)

glMatrixMode(GL_PROJECTION)
glMatrixMode(GL_MODELVIEW)
glEnable(GL_DEPTH_TEST)  # bufor głębi – odrzucanie fragmentów zasłoniętych
glEnable(GL_LIGHTING)  # włączenie obsługi oświetlenia
glLight(GL_LIGHT0, GL_POSITION, (5, 5, 5, 1))
glEnable(GL_LIGHT0)
glMaterialfv(GL_FRONT, GL_DIFFUSE, (0, 1, 1, 0.5))
lum = 1 

glEnable(GL_DEPTH_TEST)          # włącz test głębokości (z-buffer)
cube = Object("Cube")
cube2 = Object("Cube2")
cube.add_component(Rotate((0, 1, 0)))    
cube.add_component(Transform((-1, 0, 0)))       # dodanie komponentu Transform z pozycją (0,0,-1)
cube2.add_component(Rotate((1, 0, 0)))          # dodanie komponentu Rotate z kątem (0,0,0)
cube2.add_component(Transform((1, 0, 0)))       # dodanie komponentu Transform z pozycją (0,0,1)
cube.add_component(Cube(GL_POLYGON, "sciezka_do_tekstury"))
cube2.add_component(Cube(GL_POLYGON, "sciezka_do_tekstury"))
glEnable(GL_LIGHTING)            # (reszta konfiguracji światła jak wcześniej)

clock = pygame.time.Clock()
fps = 60

angle = 0
# Pętla główna aplikacji
while not done:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            done = True
        elif event.type == MOUSEBUTTONDOWN and \
                           event.button == 1:
            mouse_down = True
            last_mouse_pos = pygame.mouse.get_pos()
        elif event.type == MOUSEBUTTONUP and \
                           event.button == 1:
            mouse_down = False
        elif event.type == MOUSEMOTION and \
             mouse_down is True:
            pygame.draw.line(screen, white,
                             last_mouse_pos,
                             pygame.mouse.get_pos(),
                             5)
            last_mouse_pos = pygame.mouse.get_pos()

    # Czyścimy bufor koloru i bufor głębi
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    cube.update()  # Wywołujemy metodę rysującą model
    cube2.update()
    clock.tick(1)
    angle += 1
    glMaterialfv(GL_FRONT, GL_DIFFUSE, (1, 0, 0, lum))

    pygame.display.flip()  # Prezentujemy nowo narysowaną klatkę
    print(f"tick={clock.tick(fps)}, fps={clock.get_fps()}")

pygame.quit()  # Sprzątanie i zakończenie programu