from Mesh3D import *
from Transform import *
from Rotate import *
from Button import *

class Object:
    def __init__(self, obj_name):
        self.name = obj_name
        self.components = []
        self.angleSpeed = 0

    def add_component(self, component):
        if isinstance(component, Transform):
            self.components.insert(0, component)
        elif isinstance(component, Rotate):
            self.components.insert(0, component)
        else:
            self.components.append(component)

    def update(self, events=None):
        glPushMatrix()            # zapamiętaj bieżącą macierz transformacji
        for c in self.components:
            if isinstance(c, Transform):
                pos = c.get_position()
                glTranslatef(pos.x, pos.y, pos.z)
            if isinstance(c, Rotate):
                angle = c.get_angle()
                glRotatef(self.angleSpeed, angle.x, angle.y, angle.z)
            if isinstance(c, Mesh3D):
                c.draw()
            if isinstance(c, Button): # obsługa komponentu Button
                c.draw(events)

            self.angleSpeed += 1
        glPopMatrix()      